/*
 * 13-QQQQ.c
 */

#include <stdio.h>

/*
 *	[Ql] ̃vO͎̖߂ɗpł

̓̎Os A, B ̘aƐς߂ȂB
    |  -2  -3  -1 |
A = <   1   0   2 >
    |  -2   2  -2 |

    |  -3   1  -3 |
B = <   1  -3  -3 >
    |   2   1   2 |

 *	
 */

/*
 *
 */

#define	ARRAY_SIZE	3

/*
 *
 */

typedef	int Matrix3D[ARRAY_SIZE][ARRAY_SIZE];

/*
 *
 */

void output_Matrix3D ( Matrix3D array ) {
	 int i;
	 int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		printf ( "%c ", "|<|"[i] );
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			printf ( "%4d ", array[i][j] );
		}
		printf ( "%c\n", "|>|"[i] );
	 }
}

/*
 *
 */

void input_Matrix3D ( Matrix3D array ) {
	 int i;
	 int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			printf ( "%d, %d vf = ", i, j );
			scanf ( "%d", &array[i][j] );
		}
	}
}

/*
 *
 */

void copyto_Matrix3D( Matrix3D dst, Matrix3D src ) {
	int i;
	int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			dst[i][j] = src[i][j];
		}
	}
}

/*
 *
 */

void addto_Matrix3D( Matrix3D dst, Matrix3D src ) {
	int i;
	int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			dst[i][j] += src[i][j];
		}
	}
} 

/*
 *
 */

void multo_Matrix3D( Matrix3D dst, Matrix3D src ) {
	Matrix3D result;
	int i;
	int j;
	int k;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			result[i][j] = 0;
			for ( k = 0; k < ARRAY_SIZE; k++ ) {
				result[i][j] += dst[i][k] * src[k][j];
			}
		}
	}

	copyto_Matrix3D ( dst, result );
}


/*
 *
 */

int main ( void ) {
  Matrix3D A = {
    {  -2,  -3,  -1 },
    {   1,   0,   2 },
    {  -2,   2,  -2 } };
  Matrix3D B = {
	{  -3,   1,  -3 },
    {   1,  -3,  -3 },
    {   2,   1,   2 } };
	Matrix3D add;
	Matrix3D mul;

	copyto_Matrix3D ( add, A );
	addto_Matrix3D ( add, B );
	output_Matrix3D ( add );

	printf ( "\n" );

	copyto_Matrix3D ( mul, A );
	multo_Matrix3D ( mul, B );
	output_Matrix3D ( mul );

	return 0;
}

/*
 *
 */
